# fms 中的 cookie


fms 提供了一个前端组件可视化控制 ajax 的多种响应结果，node 代码中可通过 `req.cookies.fms` 获取控制所有响应结果的配置。 `req.cookies._` 和 `req.cookies.fms_this` 获取当前 url 响应结果的配置。

对于普通开发人员：在 node 中使用 `$.ajax(settings).done()` `$.ajax(settings).fail()` **配置**响应结果， 在浏览器中配置 `_DEV` 变量和引入 `<script src="/_" >` 可视化**控制**响应结果 [更多说明](control-response.md)

对于熟练开发人员可控制 cookie 中每个页面的 value 值，在 node 根据 `req.cookies._.value` 返回不同响应结果。

cookie 示例：

```js
{
	// $.ajax 相关
	"ajax": {
    	"/url/": {
        	"type": "success"
        },
		"/url2/": {
        	"type": "error",
			"value": "0"
        }
    },
  	// $.page 相关
	"page": {
    	"/user/": {
        	"type": "success"
        },
		"/user2/": {
        	"type": "success",
			"value": "0"
        }
    },
}
```

获取当前页面 cookie 配置

```js
$.ajax('/examples/cookie/').done(function (req, res) {
	if (req.cookies._.type === 'success') {
		return "ok"
    } else {
    	return "error"
    }
})
```