'use strict'
/*!
    doc 的作用是存储 ajax 和 page 的参数，以供需要时根据这些参数生成 markdown 格式和 html 格式文档
 */

/*!
    _data 数据结构
    [
        // 第一种：由 $.doc({data:'some'}, string) 添加
        // Ref: https://github.com/nimojs/nodeajax/issues/2
        {
            type: 'template',
            // 渲染数据源
            renderData : {
                ...
            },
            template: '模板字符串'

        },
        // 第二种：根据 $.ajax 的参数自动添加 ，/src/ajax.js
        {
            type: 'ajax',
            // 适合生成文档的 ajax 参数，在 /src/ajax.js 中过滤参数
            settings: {
                ...
            }
        }
        // 第三种：根据 $.page 的参数自动添加 ，/src/page.js
        // 暂无： page 的参数比 ajax 要复杂，需要仔细考虑如何添加
        {
            type: 'page',
            // 适合生成文档的 page 参数，在 /src/page.js 中过滤参数
            settings: {
                ...
            }
        }
    ]
 */
var _data = []
var doc = function (renderData, template) {
    var $ = require('../index')
    if (typeof renderData === 'string' || typeof renderData === 'function') {
        template = renderData
        renderData = false
    }

    if (typeof template === 'function') {
        template = $.heredoc(template)
    }
    _data.push({
        type: 'template',
        renderData: renderData,
        template: template
    })
}
module.exports = {
    _data: _data,
    doc: doc
}