'use strict'
var extend = require('extend')
var iUtil = require('./util')
var doc = require('./doc')
var fs = require('fs')
var request = require('request');
/*
$.page({
    url: '/login/',
    template: 'view/login.html',
    data: {
        some:
    },
    render: function (req, res) {
        // req.cookies._也可以是 GET参数中的 _
        switch (req.cookies._) {
            case '1':
            break
            case '2':
            break
        }
    }
})
*/
module.exports = function (settings) {
    var $ = require('../index')
    settings = extend(true, {} ,$.config.pageSettings ,settings)

    settings.url = iUtil.checkUrl(settings.url)
    // url 错误时会返回 false
    if (!settings.url){
        return false
    }
    $.handle(settings.url, 'page', 'all', function (req, res) {
        $.config.smarty.request(settings.data, req)
        settings.render(settings.data, req)
        var form = {
            data: JSON.stringify(settings.data),
            template: settings.template,
            template_dir: $._cwd + '/' + $.config.smarty.includePath
        }
        request.post({
            url: $.config.viewServer,
            form: form
        }, function (err,httpResponse,body) {
            if (err) {res.send(err)}
            body = body.replace(/(<br( \/)?>[\s\S]?.*?strftime.*?t your timezone. in.*?<br( \/)?>)/g, '<!--$1-->')
            /*
            php -S 127.0.0.1:8080 启动会出现时区设置错误，但这不影响前端模拟数据，所以使用正则屏蔽
            <br />
            <b>Warning</b>:  strftime(): It is not safe to rely on the system's timezone settings. You are *required* to use the date.timezone setting or the date_default_timezone_set() function. In case you used any of those methods and you are still getting this warning, you most likely misspelled the timezone identifier. We selected the timezone 'UTC' for now, but please set date.timezone to select your timezone. in <b>/Users/nimojs/Documents/e/app/home/src/php/lib/smarty/sysplugins/smarty_internal_templatecompilerbase.php</b> on line <b>347</b><br />
            <!DOCTYPE html>
            <html lang="en">
            <head>
            */
            res.send(body)
        })
        // var tpl = fs.readFileSync($._cwd + '/' + $.config.smarty.includePath + settings.template, 'utf-8');
        // $.config.smarty.request(settings.data, req)
        // // render 可在渲染前操作数据源，非全局，每个页面单独操作
        // settings.render(settings.data, req)
        // var html = new $.smarty(tpl).fetch(settings.data)
        // res.send(html)
    })
    doc._data.push({
        type: 'page',
        settings: settings
    })
    $._data.pages.push({
        title: settings.title || settings.url,
        url: settings.url,
        filename: settings.url
    })
}