'use strict'
var $ = require('../index')
var controller = require('./controller')
var handlers = controller.handlers
var qs = require('querystring')
var combo = require('connect-combo')
module.exports = function (req, res, next) {
    // 密码验证
    if ($.config.password && req.ip !== '127.0.0.1') {
        if (req.cookies.password != $.config.password) {
            handlers._password(req, res)
            return
        }
    }    

    // urlRewrite 暂时注释
    // rewrite rule
    // var pathname = req.path
    // if (pathname !== '/fms/') {
    //     var i = 0
    //     var iSize = $.config.urlRewrite.length
    //     for(; i<iSize; i = i + 2){
    //         var searchValue = $.config.urlRewrite[i]
    //         var replaceValue = $.config.urlRewrite[i+1]
    //         if (typeof searchValue === 'string') {
    //             // "/_console/" = "\/_console\/"
    //             searchValue = searchValue.replace(/([.$^{[(|)*+?\/\\])/g,'\\$1')
    //             searchValue = new RegExp('^' + searchValue + '$')
    //         }
    //         pathname = pathname.replace(searchValue, replaceValue)
    //     }
    // }
    
    // 处理器
    var handler = handlers[req.path]
    var handlerType = ''
    // 存在处理器
    if (typeof handler === "object") {
        // 自定义处理器
        if (typeof handler.default === 'function') {
            handler.default(req, res)
        }
        // $.ajax 和 $.page
        else {
            if (req.xhr) {
                handlerType = 'ajax'
            }
            else {
                // 当没有 $.page 存在时使用 $.ajax 的 function
                // 偶尔需要直接打开 url 查看 GET 方式 AJAX 的响应内容
                if (typeof handler['page'] === 'function') {
                    handlerType = 'page'
                }
                else {
                    handlerType = 'ajax'
                }
            }
            
            if (handler[handlerType]) {
                if (handlerType === 'ajax') {
                    if (handler[handlerType][req.method]) {
                        // handler.ajax.get(req, res)
                        handler[handlerType][req.method](req, res)
                    }
                    else {
                        next()
                    }
                }
                else {
                    // handler.page(req, res)
                    handler[handlerType](req, res)
                }
            }
            else {
                next()
            }
        }
    }
    else {
        // 静态资源
        if (/\?\?/.test(req.url)) {
            combo({
              directory: $.config.static,
              proxy: false,//'https://a.alipayobjects.com',
              cache: true,
              log: false,
              static: true
            })(req, res)
        }
        else {
            handlers['_static']['default'](req, res)
        }
    }
}